/*
	(c) Thomas Kamps, 2006
	This Code ist distributet under the GnuGPL v2
*/
#include <math.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>

#include <errno.h>

int codeChars[8];
int txtChar;

int bitCodeChars[8][8];
int bitTxtChar[8];

int fileLength;
int lengthBits[32];
int codedLengthBytes[4];

FILE *fp;
FILE *txt;
FILE *fw;

int potenz(int base, int exp) {
	int pot = 1;
	for (int i = 0; i < exp; i++) {
		pot = pot * base;
	}
	return pot;
}
void readPicChars() {
	for(int i = 0; i < 8; i++) {
		codeChars[i] = getc(fp);
	}
}

void splitPicChars() {
	for (int i = 0; i < 8; i++) {
		if (codeChars[i] >= 128) { bitCodeChars[i][0] = 1; codeChars[i] -= 128; } else bitCodeChars[i][0] = 0;
		if (codeChars[i] >=  64) { bitCodeChars[i][1] = 1; codeChars[i] -=  64; } else bitCodeChars[i][1] = 0;
		if (codeChars[i] >=  32) { bitCodeChars[i][2] = 1; codeChars[i] -=  32; } else bitCodeChars[i][2] = 0;
		if (codeChars[i] >=  16) { bitCodeChars[i][3] = 1; codeChars[i] -=  16; } else bitCodeChars[i][3] = 0;
		if (codeChars[i] >=   8) { bitCodeChars[i][4] = 1; codeChars[i] -=   8; } else bitCodeChars[i][4] = 0;
		if (codeChars[i] >=   4) { bitCodeChars[i][5] = 1; codeChars[i] -=   4; } else bitCodeChars[i][5] = 0;
		if (codeChars[i] >=   2) { bitCodeChars[i][6] = 1; codeChars[i] -=   2; } else bitCodeChars[i][6] = 0;
		if (codeChars[i] >=   1) { bitCodeChars[i][7] = 1; codeChars[i] -=   1; } else bitCodeChars[i][7] = 0;		
	}
}

void splitTxtChar() {
	if (txtChar >= 128) { bitTxtChar[0] = 1; txtChar -= 128; } else bitTxtChar[0] = 0;
	if (txtChar >=  64) { bitTxtChar[1] = 1; txtChar -=  64; } else bitTxtChar[1] = 0;
	if (txtChar >=  32) { bitTxtChar[2] = 1; txtChar -=  32; } else bitTxtChar[2] = 0;
	if (txtChar >=  16) { bitTxtChar[3] = 1; txtChar -=  16; } else bitTxtChar[3] = 0;
	if (txtChar >=   8) { bitTxtChar[4] = 1; txtChar -=   8; } else bitTxtChar[4] = 0;
	if (txtChar >=   4) { bitTxtChar[5] = 1; txtChar -=   4; } else bitTxtChar[5] = 0;
	if (txtChar >=   2) { bitTxtChar[6] = 1; txtChar -=   2; } else bitTxtChar[6] = 0;
	if (txtChar >=   1) { bitTxtChar[7] = 1; txtChar -=   1; } else bitTxtChar[7] = 0;
}

void enCodeBits() {
	for (int i = 0; i < 8; i++) {
		bitCodeChars[i][7] = !(bitTxtChar[i] == bitCodeChars[i][7]);
	}
}

void writeChars() {
	for (int i = 0; i < 8; i++) {
		codeChars[i]  = bitCodeChars[i][0] * 128;
		codeChars[i] += bitCodeChars[i][1] *  64;
		codeChars[i] += bitCodeChars[i][2] *  32;
		codeChars[i] += bitCodeChars[i][3] *  16;
		codeChars[i] += bitCodeChars[i][4] *   8;
		codeChars[i] += bitCodeChars[i][5] *   4;
		codeChars[i] += bitCodeChars[i][6] *   2;
		codeChars[i] += bitCodeChars[i][7] *   1;

		fputc(codeChars[i], fw);
	}
}

void splitFileLength() {
	lengthBits[0] = 0;
	for (int i = 1; i < 32; i++) {
		if (fileLength >= potenz(2, 31-i)) {lengthBits[i] = 1; fileLength -= potenz(2,31-i);} else lengthBits[i] = 0;
	}
}

void writeEncodedLength() {
	for (int i = 0; i < 4; i++) {
		readPicChars();
		splitPicChars();
		for (int j = 0; j < 8; j++) {
			bitCodeChars[j][7] = !(lengthBits[8*i+j] == bitCodeChars[j][7]);
		}
		writeChars();
	}
}
int main( int argc, char **args ) {

	if (argc != 4 ) {
		printf("USUAGE: picencoder originalBMP fileTohide newBMP\n");
		return 0;
	}
	int picLength;

	fp  = fopen(args[1], "r");
	if (!fp) {
		printf("File: %s does not exist!\n", args[1]);
		return 0;
	}
	
	txt = fopen(args[2], "r");
	if (!txt) {
		printf("File: %s does not exist!\n", args[2]);
		return 0;
	}
	
	fw  = fopen(args[3], "r");
	if (fw) {
		printf("File: %s does alerady exist! please specyfy a file that does not exist.\n", args[3]);
		fclose(fw);	
		return 0;
	}

	fw  = fopen(args[3], "w");
	
	fseek(txt, 0, SEEK_END);
	fileLength = ftell(txt);

	fseek(fp, 0, SEEK_END);
	picLength = ftell(fp);

	fclose(txt);
	fclose(fp);
	
	txt = fopen(args[2], "r");
	fp = fopen(args[1], "r");
	if (fp && txt && fw) {
		//Header in ordnung lassen!!!
		for( int i = 0; i < 54; i++) {
			codeChars[0] = getc(fp);
			fputc(codeChars[0], fw);
		}
		//Dateilänge codieren (32bit, oder 4 Byte)
		splitFileLength();
		writeEncodedLength();
		
		while( !feof(txt) ) {
			txtChar = getc(txt);
			//8 Bytes aus dem bild auslesen
			readPicChars();
		
			//in Bits zerlegen
			splitPicChars();
			splitTxtChar();

			//Über XOR verknüpfen
			enCodeBits();
		
			//Neue Bytes schreiben
			writeChars();
		}

		while ( ftell(fp) < picLength) {
			codeChars[0] = getc(fp);
			fputc(codeChars[0], fw);
		}
	}
	fclose(fp);
	fclose(fw);
	fclose(txt);
	return 0;
}
